/********************************************
 * UTIA AV CR, v.v.i
 * Signal Processing Department
 * Pod Vodarenskou vezi 4
 * 182 08 Prague
 * Czech Republic
 * web: http://zs.utia.cas.cz
 * contact: sp@utia.cz
 *
 * Filename: csc.h
 * Date: 09.12.2022
 * Author: Lukas Kohout <kohoutl@utia.cas.cz>
 * Description:
 *    V_PROC_SS CSC
 *
 * Changelog:
 *
 *
 *
 *
 ********************************************/


#ifndef _CSC_HEADER_FILE_
#define _CSC_HEADER_FILE_

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include <assert.h>
#include <dirent.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/mman.h>
#include <unistd.h>
#include <stddef.h>


#include "xv_csc.h"
#include "xv_csc_l2.h"
#include "../xvidc/xvidc.h"

struct struct_csc_t
{
    uintptr_t         base_addr;

    XV_Csc_l2         inst;
    XVidC_VideoStream stream_in;
    XVidC_VideoStream stream_out;
};
typedef struct struct_csc_t csc_t;


#define CSC_STREAM_IN       0
#define CSC_STREAM_OUT      1

int csc_init(csc_t *csc, const char* dev_name);
int csc_release(csc_t *csc);

int csc_init_common(csc_t *csc, XV_csc_Config *csc_config);


int csc_set_stream_param(csc_t *csc,
                         u16 dir,
                         u16 width,
                         u16 height,
                         XVidC_FrameRate fps,
                         XVidC_ColorFormat cfmt,
                         u16 interlaced
                        );


int csc_setup_mode(csc_t *csc);




#ifdef __cplusplus
}
#endif

#endif // _CSC_HEADER_FILE_
